--[[
ACM's dialog; we also keep the custom command handler here.





]]--

function ACM.CustomActionHandle(_, arg)
	
	if arg ~= nil then
		if arg[1] == "count" then
			ACM.ActionCountdownCounter = 5
			ACM.Countdown()
		elseif arg[1] == "attack" then
			if GetTargetInfo() == nil then
				print("Select a target!")
			else
				local temp = "say 'Attack my target: " .. GetTargetInfo() .. "'"
				gkinterface.GKProcessCommand(temp)
			end
		elseif arg[1] == "hide" then
			ACM.DisplayFrame.visible = "NO"
		end
	else
		print("arg is nil?")
	end
	
end

RegisterUserCommand("ACMcustom", ACM.CustomActionHandle)

function ACM.Countdown()
	local temp = "say " .. tostring(ACM.ActionCountdownCounter)
	gkinterface.GKProcessCommand(temp)
	
	ACM.ActionCountdownCounter = ACM.ActionCountdownCounter - 1
	
	if ACM.ActionCountdownCounter > 0 then
		ACM.ActionCountdownTimer:SetTimeout(1000, function() ACM.Countdown() end)
	end
	
end

local function create_subdlg(ctrl) --stolen from DB
	local dlg = iup.dialog{ctrl, border="NO", menubox="NO", resize="NO", size = "FULL", bgcolor="0 0 0 0 *",}
	dlg.visible = "YES"
	return dlg
end

local function create_scrollbox(content) --stolen from DB
	local scrollbox = iup.stationsublist{{}, control = "YES", expand = "YES",}
	iup.Append(scrollbox, create_subdlg(content))
	scrollbox[1] = 1
	return scrollbox
end

ACM.UI = {}
do --setup components for dialog
	
	ACM.UI.Custom1Title = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	ACM.UI.Custom1Action = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	
	ACM.UI.Custom2Title = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	ACM.UI.Custom2Action = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	
	ACM.UI.Custom3Title = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	ACM.UI.Custom3Action = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	
	ACM.UI.Custom4Title = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	ACM.UI.Custom4Action = iup.text {
		value = "",
		EXPAND = "HORIZONTAL",
	}
	
	ACM.UI.ActionOutputLocation = iup.stationsublist {
		DROPDOWN = "YES",
		"say_group ",
		"say_sector ",
		value = 1,
	}
	
	ACM.UI.NotifText = iup.label {
		title = "",
	}
	
end

ACM.UI.ContentFrame = iup.hbox {
	iup.vbox {
		GAP = "6",
		ALIGNMENT = "ALEFT",
		iup.label {
			title = "Custom Actions:",
		},
		
		
		iup.label {
			title = "\nAction 1:",
		},
		iup.hbox {
			iup.label {
				title = "Title: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom1Title,
			},
		},
		iup.hbox {
			iup.label {
				title = "Command: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom1Action,
			},
		},
		
		iup.label {
			title = "\nAction 2:",
		},
		iup.hbox {
			iup.label {
				title = "Title: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom2Title,
			},
		},
		iup.hbox {
			iup.label {
				title = "Command: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom2Action,
			},
		},
		
		iup.label {
			title = "\nAction 3:",
		},
		iup.hbox {
			iup.label {
				title = "Title: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom3Title,
			},
		},
		iup.hbox {
			iup.label {
				title = "Command: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom3Action,
			},
		},
		
		iup.label {
			title = "\nAction 4:",
		},
		iup.hbox {
			iup.label {
				title = "Title: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom4Title,
			},
		},
		iup.hbox {
			iup.label {
				title = "Command: ",
			},
			iup.vbox {
				ALIGNMENT = "ARIGHT",
				ACM.UI.Custom4Action,
			},
		},
		
		iup.hbox {
			iup.vbox {
				MARGIN = "6x6",
				iup.label {
					title = "ACM Output Location: ",
				},
				ACM.UI.ActionOutputLocation,
			},
			
			iup.vbox {
				MARGIN = "6x6",
				iup.stationbutton {
					title = "bind ACM to buttons '1, 2, 3, 4'",
					action = function(self)
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("1"), "ACM1")
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("2"), "ACM2")
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("3"), "ACM3")
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("4"), "ACM4")
						ACM.UI.NotifText.title = "ACM bound to buttons 1-4. 1 is the top, 4 is the bottom."
						iup.Refresh(ACM.UI.NotifText)
					end,
				},
				iup.stationbutton {
					title = "bind ACM to the arrow keys",
					action = function(self)
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("UpArrow"), "ACM1")
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("RightArrow"), "ACM2")
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("LeftArrow"), "ACM3")
						gkinterface.BindCommand(gkinterface.GetInputCodeByName("DownArrow"), "ACM4")
						ACM.UI.NotifText.title = "ACM bound to the arrow keys. Up is top, then right, left, and down is the bottom."
						iup.Refresh(ACM.UI.NotifText)
					end,
				},
			},
		},
		
		ACM.UI.NotifText,
		
	},
}

ACM.UI.XFrame = create_scrollbox(ACM.UI.ContentFrame)

ACM.UI.Dialog = iup.dialog {
	TOPMOST = "YES",
	BGCOLOR = "0 0 0 160 *",
	FULLSCREEN = "YES",
	ALIGNMENT = "ACENTER",
	DEFAULTESC = ACM.UI.Hide,
	iup.vbox {
		iup.fill{},
		iup.stationsubframe {
			iup.vbox {
				EXPAND = "HORIZONTAL",
				SIZE = HUDSize(1, 0.8),
				
				iup.hbox {
					iup.fill {},
					iup.vbox {
						ALIGNMENT = "ACENTER",
						iup.label {
							title = "\127FFAA00Action Command Menu",
							font = Font.H1,
						},
						iup.label {
							title = "Configuration Menu\n",
							font = Font.H3
						},
					},
					iup.fill {},
				},
				
				ACM.UI.XFrame,
				
				iup.fill{},
				iup.hbox {
					iup.fill {},
					iup.vbox {
						ALIGNMENT = "ACENTER",
						iup.hbox {
							iup.stationbutton {
								title = "Save",
								action = function(self)
									if ACM.UI.Custom1Title ~= "" then
										ACM.ComList[3][1] = {}
										ACM.ComList[3][1][0] = ACM.UI.Custom1Title.value
										ACM.ComList[3][1]['Action'] = ACM.UI.Custom1Action.value
									end
									if ACM.UI.Custom2Title ~= "" then
										ACM.ComList[3][2] = {}
										ACM.ComList[3][2][0] = ACM.UI.Custom2Title.value
										ACM.ComList[3][2]['Action'] = ACM.UI.Custom2Action.value
									end
									if ACM.UI.Custom3Title ~= "" then
										ACM.ComList[3][3] = {}
										ACM.ComList[3][3][0] = ACM.UI.Custom3Title.value
										ACM.ComList[3][3]['Action'] = ACM.UI.Custom3Action.value
									end
									if ACM.UI.Custom4Title ~= "" then
										ACM.ComList[3][4] = {}
										ACM.ComList[3][4][0] = ACM.UI.Custom4Title.value
										ACM.ComList[3][4]['Action'] = ACM.UI.Custom4Action.value
									end
									if ACM.UI.ActionOutputLocation.value == "1" then
										ACM.OutputLoc = "say_group"
									else
										ACM.OutputLoc = "say_sector"
									end
									gkini.WriteString("ACM", "ComList", spickle(ACM.ComList))
									gkini.WriteString("ACM", "OutputLoc", ACM.OutputLoc)
									ACM.UI.NotifText.title = "ACM configuration saved!"
								end,
							},
							iup.stationbutton {
								title = "Close",
								action = function(self)
									ACM.UI.Hide()
								end,
							},
						},
					},
					iup.fill {},
				},
			},
		},
		iup.fill{},
	},
	
}
ACM.UI.Dialog:map()

function ACM.UI.Show()
	ShowDialog(ACM.UI.Dialog)
	iup.Refresh(ACM.UI.Dialog)
end

function ACM.UI.Hide()
	ACM.UI.NotifText.title = ""
	HideDialog(ACM.UI.Dialog)
end

RegisterUserCommand("ACMConfig", ACM.UI.Show)

function ACM.UI.RunAfterLoad()
	
	if ACM.ComList[3][1] ~= nil then
		ACM.UI.Custom1Title.value = ACM.ComList[3][1][0] or ""
		ACM.UI.Custom1Action.value = ACM.ComList[3][1]['Action'] or ""
	end
	if ACM.ComList[3][2] ~= nil then
		ACM.UI.Custom2Title.value = ACM.ComList[3][2][0] or ""
		ACM.UI.Custom2Action.value = ACM.ComList[3][2]['Action'] or ""
	end
	if ACM.ComList[3][3] ~= nil then
		ACM.UI.Custom3Title.value = ACM.ComList[3][3][0] or ""
		ACM.UI.Custom3Action.value = ACM.ComList[3][3]['Action'] or ""
	end
	if ACM.ComList[3][4] ~= nil then
		ACM.UI.Custom4Title.value = ACM.ComList[3][4][0] or ""
		ACM.UI.Custom4Action.value = ACM.ComList[3][4]['Action'] or ""
	end
	
	if ACM.OutputLoc == "say_group" then
		ACM.UI.ActionOutputLocation.value = 1
	else
		ACM.UI.ActionOutputLocation.value = 2
	end
	
end

RegisterEvent(ACM.UI.RunAfterLoad, "PLAYER_ENTERED_GAME")









